/*
 * ConnectionEvent.java
 *
 * Created on 14 giugno 2005, 21.46
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package org.jaebi.midlet.bt;

import javax.microedition.io.StreamConnection;

/**
 * Classa che incapsula tutte le informazioni riguardanti l'"evento" connessione.
 * L'aggiunta di una nuova connessione al ConnectionSet provoca un evento (incapsulato
 *nell'istanza di questa classe) tale evento viene inviato al ConnectionObserver che intraprende
 * l'opportuna azione di gestione
 * @author Antonio
 */
public class ConnectionEvent {
    
    /**
     * costanti che codificano i possibili eventi che possono scatenare un 
     * notifyObserver() in ConnectionSet
     */
    public static final int CONNECTION_ADDED = 0;
    public static final int CONNECTION_REMOVED = 1;
    
    private int event;
    private StreamConnection conn;
    
    /** Creates a new instance of ConnectionEvent */
    public ConnectionEvent(int event, StreamConnection conn) {
        this.event = event;
        this.conn = conn;
    }
    
    public int getEvent(){
        return this.event;
    }
    
    public StreamConnection getConnection(){
        return this.conn;
    }
    
}
