/*
 * DiscoveryError.java
 *
 * Created on 1 giugno 2005, 17.35
 *
 * Questa classe incapsula tutte le info circa gli eventuali errori che si 
 * possono verificare durante il discovering di device e/o servizi, codificati 
 * attraverso delle costanti statiche intere. 
 * Nel momento in cui questa classe viene istanziata,  possibile associare al 
 * codice di errore un opportuno messaggio. 
 *
 */

package org.jaebi.midlet.bt.discoveryHandling;

/**
 *
 * @author Antonio
 */
public class DiscoveryError {
    
    //chiamata a Discoverer.destroy() durante la ricerca delle device o dei servizi
    public static final int DISCOVERY_INTERRUPTION = 0;
            
    /** durante una delle 2 wait  stata lanciata una interrupted Exception**/
    public static final int UNEXPECTED_DISCOVERY_INTERRUPTION = 1;
    
    /** response code, ritornato dalla ricerca delle device/servizi, sconosciuto **/
    public static final int UNKNOWN_DISCOVERY_CODE = 3;
    
    private int errorCode;
    
    private String msg;
    
    
    
    
    
    /** Creates a new instance of DiscoveryError 
     * TODO trovare un modo per obbligare chi usa sta classe ad usare le costanti
     * es. costruttore lancia eccezione se l'intero passato non sta nel range
     */
    public DiscoveryError(int errorCode, String msg){
        this.errorCode = errorCode;
        this.msg = msg;
    }
    
    public int getErrorCode(){
        return errorCode;
    }
    
    public String getMsg(){
        return msg;
    }
}
