package org.jaebi.midlet.bt.discoveryHandling;

import java.util.Enumeration;
import java.util.Vector;
import javax.bluetooth.RemoteDevice;
/*
 * DiscoveryEventHandler.java
 *
 * Created on 9 giugno 2005, 19.04
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

/**
 *
 * @author Antonio
 */
public interface DiscoveryEventHandler {
    public void discoveryStarted();
    
    public void discoveryError(DiscoveryError error);
    
    /**
     * handler richiamato quando termina l'inquiry ed ha inizio la ricerca dei 
     * servizi disponibili sulle device trovate.
     *@param devices Enumeration delle devices bluetooth trovate durante 
     * l'inquiry e sui cui verr effettuata la ricerca
     */
    public void serviceSearchStarted(Enumeration devices);
    
    /**
     * handler richiamato quando si verifica un errore durante la ricerca di 
     * servizi su una device (nessun record trovato, device non raggiungibile, ecc)
     * @param error dettagli sull'errore riscontrato
     */
    public void serviceSearchError(ServiceSearchError error);
    
    /*
     * handler richiamato quando la ricerca dei servizi per una certa device 
     *  terminata
     */
    public void servicesFound(Vector services, RemoteDevice rd);
    
    public void discoveryCompleted(DiscoveryReport report);
}
