/*
 * ServiceSearchError.java
 *
 * Created on 6 giugno 2005, 17.27
 * Questa classe incapsula gli errori
 * TODO in questa classe vedo anche le costanti 
 */

package org.jaebi.midlet.bt.discoveryHandling;

import javax.bluetooth.RemoteDevice;

/**
 *
 * @author Antonio
 */
public class ServiceSearchError extends DiscoveryError {
    
    /** non  possibile cominciare la ricerca di servizi*/
    public static final int CANT_START_SEARCH = 2;
    
    public static final int SEARCH_ERROR = 3;
    
    public static final int SEARCH_TERMINATED = 4;
    
    public static final int NO_RECORD = 5;
    
    public static final int DEVICE_NOT_REACHABLE = 6;
    
    public static final int UNEXPECTED_TRANS_ID = 7;
    
    
    
    
   
    /** istanza della device bluetooth a cui l'errore si riferisce*/
    private RemoteDevice remoteDevice = null;
    
    private int errorCode;
    
    private String errorMsg;
    
    /** Creates a new instance of ServiceSearchError */
    public ServiceSearchError(int errorCode, String msg, RemoteDevice rd){
        super(errorCode, msg);
        this.remoteDevice = rd;
    }
    
    /*
     * ritorna la device Bt su cui  avvenuto l'errore, null se l'errore ha codice
     * UNEXPECTED_TRANS_ID
     */
    public RemoteDevice getRemoteDevice(){
        return remoteDevice;
    }
    
}
