/*
 * ClientMidlet.java
 *
 * Created on 9 giugno 2005, 17.33
 */

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;
import javax.bluetooth.DataElement;
import javax.bluetooth.RemoteDevice;
import javax.bluetooth.ServiceRecord;
import javax.bluetooth.UUID;
import javax.microedition.io.StreamConnection;
import javax.microedition.lcdui.AlertType;
import javax.microedition.lcdui.Image;
import javax.microedition.midlet.*;
import org.jaebi.midlet.bt.*;
import org.jaebi.midlet.bt.btException.BtInitException;
import org.jaebi.midlet.bt.btException.ConnectionException;
import org.jaebi.midlet.bt.responseHandling.AccountingResponseHandler;
import org.jaebi.midlet.bt.responseHandling.XResponseHandler;
import org.jaebi.midlet.bt.discoveryHandling.DiscoveryReport;
import org.jaebi.midlet.bt.discoveryHandling.DiscoveryEventHandler;
import org.jaebi.midlet.bt.discoveryHandling.ServiceSearchError;
import org.jaebi.midlet.bt.discoveryHandling.DiscoveryError;


/**
 *
 * @author Antonio
 */
public class ClientMidlet extends MIDlet implements DiscoveryEventHandler, XResponseHandler, AccountingResponseHandler, javax.microedition.lcdui.CommandListener, Runnable{
    
    private BtClient client;
    private UUID UUIDset[];
    private int attrset[] = null;
    private Image serviceSearchInProgress = null;
    private Image serviceSearchDone = null;
    private Image serviceSearchError = null;
    
    
    //TODO invece di usare lengthhashtable usare i vector:quando si falsel'add nella list si falsel'add anche nel vector, cos lengthdevice sono memorizzate sia in List che in Vector con lo stesso indice
    /*
     * hashtable degli indici del componente List deviceFounded memorizzati in
     * chiave della RemoteDevice cui si riferiscono
     * -utile nell'implementazione dell'handeler servicesFound()
     */
    private Hashtable deviceListIndex;
    
    /*
     * hashtable di vettori di ServiceRecord, memorizzati in chiave degli indici
     * di deviceFounded. Ogni elemento rappresenta i servizi
     * disponibili sulla device corrispondente all'indice in device founded in
     * chiave del quale  memorizzato in questa hashtable
     */
    private Hashtable services;
    
    /**
     * hashtable di stringhe memorizzate in chiave dgli indici di deviceFounded.
     * le stringhe indicano informazioni circa gli errori avvenuti durante
     * la ricerca dei servizi (se mai ve ne fossero). Se avviene un errore sulla
     * device x, la chiave in base alla quale verr memorizzata la stringa di 
     * errore  data da deviceListIndex.get(x) 
     */
    private Hashtable serviceSearchErrorMsg;
    
    private static final UUID JAEBI_MIDLET_UUID = new UUID(0x12345);
    
    private StreamConnection conn;
    private DataInputStream streamFromServer;
    private DataOutputStream streamToServer;
    
    /*
     *__________________________________________________________________________
     *
     * Dichiarazione dei request Processor
     *__________________________________________________________________________
     *
     */
    private LoginRequestProcessor loginRequestProcessor;
    private SelectXRequestProcessor selectProcessor;
    
    /** Creates a new instance of ClientMidlet */
    public ClientMidlet() {
        this.UUIDset = new UUID[2];
        this.attrset = new int[1];
        
        //Consideriamo servizi del profilo btssp (vedi javadoc per classe UUID)
        UUIDset[0] = new UUID(0x1101);
        
        
        //e in particolare al servizio JAEBI midlet
        UUIDset[1] = JAEBI_MIDLET_UUID;
        
        //degli attributi ci interssa solo il nome del servizio
        attrset[0] = 0x100;
        
        try{
            client = new BtClient(UUIDset, attrset, this);
        } catch (BtInitException e){
            
            //visualizzo l'alert di errore con un opportuno messaggio
            get_alertError().setTitle("Errore irreversibile");
            get_alertError().setString(e.getMessage());
            javax.microedition.lcdui.Display.getDisplay(this).setCurrent(get_alertError());
            e.printStackTrace();
        }
        
        this.deviceListIndex = new Hashtable();
        this.services = new Hashtable();
        this.serviceSearchErrorMsg = new Hashtable();  
        this.loginRequestProcessor = new LoginRequestProcessor();
        this.selectProcessor = new SelectXRequestProcessor();
        
        
        
        
    }
    
// --- This section is auto-generated by NetBeans IDE. Do not modify or you may lose your changes.//<editor-fold id="MVDMethods" defaultstate="collapsed" desc="This section is auto-generated by NetBeans IDE.">//GEN-BEGIN:MVDMethods
    /**
     * This method initializes UI of the application.
     */
    private void initialize() {
// For adding user code into this block, select "Design" item in the inspector and invoke property editor on Action property in Properties window.
        javax.microedition.lcdui.Display.getDisplay(this).setCurrent(get_alertSplashScreen());
    }
    
    /**
     * Called by the system to indicate that a command has been invoked on a particular displayable.
     * @param command the Command that ws invoked
     * @param displayable the Displayable on which the command was invoked
     **/
    public void commandAction(javax.microedition.lcdui.Command command, javax.microedition.lcdui.Displayable displayable) {
        if (displayable == alertDiscoveryStart) {
            if (command == okCommandDiscoveryStart) {
// For adding user code into this block, select "Design | Screens | alertDiscoveryStart [Alert] | Assigned Commands | okCommandDiscoveryStart" item in the inspector and invoke property editor on Action property in Properties window.
                client.startDiscovery();
                setupServiceSearchIndicator();
                javax.microedition.lcdui.Display.getDisplay(this).setCurrent(get_deviceFounded());
            }
        } else if (displayable == alertError) {
            if (command == exitBluetoothInitError) {
// For adding user code into this block, select "Design | Screens | alertError [Alert] | Assigned Commands | exitBluetoothInitError" item in the inspector and invoke property editor on Action property in Properties window.
                javax.microedition.lcdui.Display.getDisplay(this).setCurrent(null);
                destroyApp(true);
                notifyDestroyed();
            }
        } else if (displayable == alertLoginCorrect) {
            if (command == okCommandLogincorrect) {
// For adding user code into this block, select "Design | Screens | alertLoginCorrect [Alert] | Assigned Commands | okCommandLogincorrect" item in the inspector and invoke property editor on Action property in Properties window.
                javax.microedition.lcdui.Display.getDisplay(this).setCurrent(get_userChoice());
            }
        } else if (displayable == alertLoginIncorrect) {
            if (command == okCommandLoginCorrect) {
// For adding user code into this block, select "Design | Screens | alertLoginIncorrect [Alert] | Assigned Commands | okCommandLoginCorrect" item in the inspector and invoke property editor on Action property in Properties window.
                javax.microedition.lcdui.Display.getDisplay(this).setCurrent(get_loginScreen());
            }
        } else if (displayable == deviceFounded) {
            if (command == ViewServices) {
// For adding user code into this block, select "Design | Screens | deviceFounded [List] | Assigned Commands | ViewServices" item in the inspector and invoke property editor on Action property in Properties window.
                get_servicesList().deleteAll();
                
//recupero l'indice della device di cui si vuole visualizzare i servizi
                Integer index = new Integer( get_deviceFounded().getSelectedIndex());
                
//controllo se ci sono stati errori durante la ricerca dei servizi su questa device
                if (serviceSearchErrorMsg.containsKey(index)){
                    
                    //visualizzo l'alert di errore con un opportuno messaggio
                    get_alertService().setTitle("Errore");
                    get_alertService().setString((String)serviceSearchErrorMsg.get(index));
                    javax.microedition.lcdui.Display.getDisplay(this).setCurrent(get_alertService());
                } else{
                    //controllo se la ricerca dei servizi su questa device  terminata
                    if (!services.containsKey(index)){
                        
                        //visualizzo l'alert di errore con un opportuno messaggio
                        get_alertService().setTitle("Attenzione");
                        get_alertService().setString("La ricerca di servizi per questa device non  ancora terminata");
                        javax.microedition.lcdui.Display.getDisplay(this).setCurrent(get_alertService());
                    } else{
        /*______________________________
         *visualizzo i servizi
         *______________________________
         */
                        get_servicesList().getTicker().setString("Elenco servizi disponibili per questa periferica");
                        Vector servicesOnDevice = (Vector)services.get(index);
                        
                        for (int i=0; i<servicesOnDevice.size(); i++){
                            //recupero il servizio ed il relativo nome
                            ServiceRecord service = (ServiceRecord)servicesOnDevice.elementAt(i);
                            String serviceName = "Servizio senza nome " + i;
                            
            /*
             * per il perch si esegua questa operazione per recuperare il nome
             * del servizio si rimanda al javadoc per javax.bluetooth.ServiceRecord
             */
                            DataElement nameElement = service.getAttributeValue(256);
                            
            /*
             ** Una cosa  poco chiara. l'offset per recuperare il service name  0 e
             * l'offset  256. nonostante 256 faccia parte dell'attrlist con cui si
             *istanzia BtClient, l'attributo col nome del servizio non viene ritornato
             */
                            if( (nameElement != null) && nameElement.getDataType() == DataElement.STRING){
                                serviceName = (String)(nameElement.getValue());
                            }
                            
                            get_servicesList().append(serviceName,null);
                        }
                        javax.microedition.lcdui.Display.getDisplay(this).setCurrent(get_servicesList());
                    }
                    
                }
            } else if (command == stopCommand1) {
// For adding user code into this block, select "Design | Screens | deviceFounded [List] | Assigned Commands | stopCommand1" item in the inspector and invoke property editor on Action property in Properties window.
//client.cancelDiscovery();
                System.out.println("funziona");
            }
        } else if (displayable == loginScreen) {
            if (command == okCommandLoginScreen) {
// For adding user code into this block, select "Design | Screens | loginScreen [TextBox] | Assigned Commands | okCommandLoginScreen" item in the inspector and invoke property editor on Action property in Properties window.
                this.loginRequestProcessor.setNickName(get_loginScreen().getString());
                this.loginRequestProcessor.processRequest(this,this.streamFromServer, this.streamToServer);
//TODO debug
                System.out.println("Client login screen: ha fatto quello che dovrebbe fare");
            }
        } else if (displayable == selectResultbox) {
            if (command == backCommandSelectResultBox) {
// For adding user code into this block, select "Design | Screens | selectResultbox [TextBox] | Assigned Commands | backCommandSelectResultBox" item in the inspector and invoke property editor on Action property in Properties window.
                javax.microedition.lcdui.Display.getDisplay(this).setCurrent(get_tableNameBox());
            }
        } else if (displayable == servicesList) {
            if (command == backToDeviceFounded) {
// For adding user code into this block, select "Design | Screens | servicesList [List] | Assigned Commands | backToDeviceFounded" item in the inspector and invoke property editor on Action property in Properties window.
                javax.microedition.lcdui.Display.getDisplay(this).setCurrent(get_deviceFounded());
            } else if (command == connect) {
// For adding user code into this block, select "Design | Screens | servicesList [List] | Assigned Commands | connect" item in the inspector and invoke property editor on Action property in Properties window.
                new Thread(this).start();
                javax.microedition.lcdui.Display.getDisplay(this).setCurrent(get_loginScreen());
            }
        } else if (displayable == tableNameBox) {
            if (command == okCommandTableNameBox) {
// For adding user code into this block, select "Design | Screens | tableNameBox [TextBox] | Assigned Commands | okCommandTableNameBox" item in the inspector and invoke property editor on Action property in Properties window.
                selectProcessor.setTableName(get_tableNameBox().getString());
                selectProcessor.processRequest(this, this.streamFromServer, this.streamToServer);
            }
        } else if (displayable == userChoice) {
            if (command == okCommandUserChoice) {
// For adding user code into this block, select "Design | Screens | userChoice [List] | Assigned Commands | okCommandUserChoice" item in the inspector and invoke property editor on Action property in Properties window.
                
                int index = get_userChoice().getSelectedIndex();
                if (index == 0){
                    javax.microedition.lcdui.Display.getDisplay(this).setCurrent(get_tableNameBox());
                }
                
                if (index == 1){
                    //TODO esegui logout
                }
            }
        }
    }
    
    /**
     * This method returns instance for deviceFounded component and should be called instead of accessing deviceFounded field directly.
     * @return Instance for deviceFounded component
     **/
    private javax.microedition.lcdui.List get_deviceFounded() {
        if (deviceFounded == null) {
            deviceFounded = new javax.microedition.lcdui.List("Inserire user name", javax.microedition.lcdui.Choice.IMPLICIT, new java.lang.String[0], new javax.microedition.lcdui.Image[0]);
            deviceFounded.addCommand(get_stopCommand1());
            deviceFounded.addCommand(get_ViewServices());
            deviceFounded.setCommandListener(this);
            deviceFounded.setTicker(get_tickerDeviceSearch());
            deviceFounded.setSelectedFlags(new boolean[0]);
            deviceFounded.setSelectCommand(get_ViewServices());
        }
        return deviceFounded;
    }
    
    /**
     * This method returns instance for alertDiscoveryStart component and should be called instead of accessing alertDiscoveryStart field directly.
     * @return Instance for alertDiscoveryStart component
     **/
    private javax.microedition.lcdui.Alert get_alertDiscoveryStart() {
        if (alertDiscoveryStart == null) {
            alertDiscoveryStart = new javax.microedition.lcdui.Alert("JAEBI Midlet Bluetooth client\n", "Cominciare ora la ricerca delle device Bluetooth?", null, javax.microedition.lcdui.AlertType.INFO);
            alertDiscoveryStart.addCommand(get_okCommandDiscoveryStart());
            alertDiscoveryStart.setCommandListener(this);
            alertDiscoveryStart.setTimeout(-2);
        }
        return alertDiscoveryStart;
    }
    
    /**
     * This method returns instance for alertError component and should be called instead of accessing alertError field directly.
     * @return Instance for alertError component
     **/
    private javax.microedition.lcdui.Alert get_alertError() {
        if (alertError == null) {
            alertError = new javax.microedition.lcdui.Alert("Errore irreversibile", "<Enter Text>", null, javax.microedition.lcdui.AlertType.INFO);
            alertError.addCommand(get_exitBluetoothInitError());
            alertError.setCommandListener(this);
            alertError.setTimeout(-2);
        }
        return alertError;
    }
    
    /**
     * This method returns instance for okCommandDiscoveryStart component and should be called instead of accessing okCommandDiscoveryStart field directly.
     * @return Instance for okCommandDiscoveryStart component
     **/
    private javax.microedition.lcdui.Command get_okCommandDiscoveryStart() {
        if (okCommandDiscoveryStart == null) {
            okCommandDiscoveryStart = new javax.microedition.lcdui.Command("Ok", javax.microedition.lcdui.Command.OK, 1);
        }
        return okCommandDiscoveryStart;
    }
    
    /**
     * This method returns instance for exitBluetoothInitError component and should be called instead of accessing exitBluetoothInitError field directly.
     * @return Instance for exitBluetoothInitError component
     **/
    private javax.microedition.lcdui.Command get_exitBluetoothInitError() {
        if (exitBluetoothInitError == null) {
            exitBluetoothInitError = new javax.microedition.lcdui.Command("Exit", javax.microedition.lcdui.Command.EXIT, 1);
        }
        return exitBluetoothInitError;
    }
    
    /**
     * This method returns instance for tickerDeviceSearch component and should be called instead of accessing tickerDeviceSearch field directly.
     * @return Instance for tickerDeviceSearch component
     **/
    private javax.microedition.lcdui.Ticker get_tickerDeviceSearch() {
        if (tickerDeviceSearch == null) {
            tickerDeviceSearch = new javax.microedition.lcdui.Ticker("Ricerca delle device in corso");
        }
        return tickerDeviceSearch;
    }
    
    /**
     * This method returns instance for stopCommand1 component and should be called instead of accessing stopCommand1 field directly.
     * @return Instance for stopCommand1 component
     **/
    private javax.microedition.lcdui.Command get_stopCommand1() {
        if (stopCommand1 == null) {
            stopCommand1 = new javax.microedition.lcdui.Command("Stop", javax.microedition.lcdui.Command.STOP, 1);
        }
        return stopCommand1;
    }
    
    /**
     * This method returns instance for ViewServices component and should be called instead of accessing ViewServices field directly.
     * @return Instance for ViewServices component
     **/
    private javax.microedition.lcdui.Command get_ViewServices() {
        if (ViewServices == null) {
            ViewServices = new javax.microedition.lcdui.Command("Servizi", "Visualizza i servizi disponibili su questa device", javax.microedition.lcdui.Command.ITEM, 1);
        }
        return ViewServices;
    }
    
    /**
     * This method returns instance for servicesList component and should be called instead of accessing servicesList field directly.
     * @return Instance for servicesList component
     **/
    private javax.microedition.lcdui.List get_servicesList() {
        if (servicesList == null) {
            servicesList = new javax.microedition.lcdui.List("Inserire lo username", javax.microedition.lcdui.Choice.EXCLUSIVE, new java.lang.String[0], new javax.microedition.lcdui.Image[0]);
            servicesList.addCommand(get_backToDeviceFounded());
            servicesList.addCommand(get_connect());
            servicesList.setCommandListener(this);
            servicesList.setTicker(get_tickerServiceList());
            servicesList.setSelectedFlags(new boolean[0]);
            servicesList.setSelectCommand(get_connect());
        }
        return servicesList;
    }
    
    /**
     * This method returns instance for backToDeviceFounded component and should be called instead of accessing backToDeviceFounded field directly.
     * @return Instance for backToDeviceFounded component
     **/
    private javax.microedition.lcdui.Command get_backToDeviceFounded() {
        if (backToDeviceFounded == null) {
            backToDeviceFounded = new javax.microedition.lcdui.Command("Back", javax.microedition.lcdui.Command.BACK, 1);
        }
        return backToDeviceFounded;
    }
    
    /**
     * This method returns instance for alertSplashScreen component and should be called instead of accessing alertSplashScreen field directly.
     * @return Instance for alertSplashScreen component
     **/
    private javax.microedition.lcdui.Alert get_alertSplashScreen() {
        if (alertSplashScreen == null) {
            alertSplashScreen = new javax.microedition.lcdui.Alert("", "", get_splashScreen(), javax.microedition.lcdui.AlertType.INFO);
            alertSplashScreen.setTimeout(3000);
            javax.microedition.lcdui.Display.getDisplay(this).setCurrent(get_alertDiscoveryStart());
        }
        return alertSplashScreen;
    }
    
    /**
     * This method returns instance for splashScreen component and should be called instead of accessing splashScreen field directly.
     * @return Instance for splashScreen component
     **/
    private javax.microedition.lcdui.Image get_splashScreen() {
        if (splashScreen == null) {
            try {
                splashScreen = javax.microedition.lcdui.Image.createImage("/images/jaebi LogoFinal.jpg");
            } catch (java.io.IOException exception) {
            }
        }
        return splashScreen;
    }
    
    /**
     * This method returns instance for alertService component and should be called instead of accessing alertService field directly.
     * @return Instance for alertService component
     **/
    private javax.microedition.lcdui.Alert get_alertService() {
        if (alertService == null) {
            alertService = new javax.microedition.lcdui.Alert("alert service", "<Enter Text>", null, javax.microedition.lcdui.AlertType.WARNING);
            alertService.setTimeout(-2);
        }
        return alertService;
    }
    
    /**
     * This method returns instance for tickerServiceList component and should be called instead of accessing tickerServiceList field directly.
     * @return Instance for tickerServiceList component
     **/
    private javax.microedition.lcdui.Ticker get_tickerServiceList() {
        if (tickerServiceList == null) {
            tickerServiceList = new javax.microedition.lcdui.Ticker("<Enter Ticker Text>");
        }
        return tickerServiceList;
    }
    
    /**
     * This method returns instance for connect component and should be called instead of accessing connect field directly.
     * @return Instance for connect component
     **/
    private javax.microedition.lcdui.Command get_connect() {
        if (connect == null) {
            connect = new javax.microedition.lcdui.Command("Connetti", javax.microedition.lcdui.Command.ITEM, 1);
        }
        return connect;
    }
    
    /**
     * This method returns instance for loginScreen component and should be called instead of accessing loginScreen field directly.
     * @return Instance for loginScreen component
     **/
    private javax.microedition.lcdui.TextBox get_loginScreen() {
        if (loginScreen == null) {
            loginScreen = new javax.microedition.lcdui.TextBox("Inserisci lo user name", "", 120, 0x0);
            loginScreen.addCommand(get_okCommandLoginScreen());
            loginScreen.setCommandListener(this);
        }
        return loginScreen;
    }
    
    /**
     * This method returns instance for okCommandLoginScreen component and should be called instead of accessing okCommandLoginScreen field directly.
     * @return Instance for okCommandLoginScreen component
     **/
    private javax.microedition.lcdui.Command get_okCommandLoginScreen() {
        if (okCommandLoginScreen == null) {
            okCommandLoginScreen = new javax.microedition.lcdui.Command("Ok", javax.microedition.lcdui.Command.OK, 1);
        }
        return okCommandLoginScreen;
    }
    
    /**
     * This method returns instance for alertLoginIncorrect component and should be called instead of accessing alertLoginIncorrect field directly.
     * @return Instance for alertLoginIncorrect component
     **/
    private javax.microedition.lcdui.Alert get_alertLoginIncorrect() {
        if (alertLoginIncorrect == null) {
            alertLoginIncorrect = new javax.microedition.lcdui.Alert("Errore", "<Enter Text>", null, javax.microedition.lcdui.AlertType.ERROR);
            alertLoginIncorrect.addCommand(get_okCommandLoginCorrect());
            alertLoginIncorrect.setCommandListener(this);
            alertLoginIncorrect.setTimeout(-2);
        }
        return alertLoginIncorrect;
    }
    
    /**
     * This method returns instance for okCommandLoginCorrect component and should be called instead of accessing okCommandLoginCorrect field directly.
     * @return Instance for okCommandLoginCorrect component
     **/
    private javax.microedition.lcdui.Command get_okCommandLoginCorrect() {
        if (okCommandLoginCorrect == null) {
            okCommandLoginCorrect = new javax.microedition.lcdui.Command("Ok", javax.microedition.lcdui.Command.OK, 1);
        }
        return okCommandLoginCorrect;
    }
    
    /**
     * This method returns instance for updateValue component and should be called instead of accessing updateValue field directly.
     * @return Instance for updateValue component
     **/
    private javax.microedition.lcdui.Command get_updateValue() {
        if (updateValue == null) {
            updateValue = new javax.microedition.lcdui.Command("Modifica", javax.microedition.lcdui.Command.SCREEN, 1);
        }
        return updateValue;
    }
    
    /**
     * This method returns instance for alertLoginCorrect component and should be called instead of accessing alertLoginCorrect field directly.
     * @return Instance for alertLoginCorrect component
     **/
    private javax.microedition.lcdui.Alert get_alertLoginCorrect() {
        if (alertLoginCorrect == null) {
            alertLoginCorrect = new javax.microedition.lcdui.Alert(null, "<Enter Text>", null, javax.microedition.lcdui.AlertType.INFO);
            alertLoginCorrect.addCommand(get_okCommandLogincorrect());
            alertLoginCorrect.setCommandListener(this);
            alertLoginCorrect.setTimeout(-2);
        }
        return alertLoginCorrect;
    }
    
    /**
     * This method returns instance for okCommandLogincorrect component and should be called instead of accessing okCommandLogincorrect field directly.
     * @return Instance for okCommandLogincorrect component
     **/
    private javax.microedition.lcdui.Command get_okCommandLogincorrect() {
        if (okCommandLogincorrect == null) {
            okCommandLogincorrect = new javax.microedition.lcdui.Command("Ok", javax.microedition.lcdui.Command.OK, 1);
        }
        return okCommandLogincorrect;
    }
    
    /**
     * This method returns instance for userChoice component and should be called instead of accessing userChoice field directly.
     * @return Instance for userChoice component
     **/
    private javax.microedition.lcdui.List get_userChoice() {
        if (userChoice == null) {
            userChoice = new javax.microedition.lcdui.List("Seleziona l\'operazione da eseguire", javax.microedition.lcdui.Choice.IMPLICIT, new java.lang.String[0], new javax.microedition.lcdui.Image[0]);
            userChoice.addCommand(get_okCommandUserChoice());
            userChoice.setCommandListener(this);
            userChoice.setSelectedFlags(new boolean[0]);
            get_userChoice().append("Select", null);
            get_userChoice().append("Logout", null);
        }
        return userChoice;
    }
    
    /**
     * This method returns instance for okCommandUserChoice component and should be called instead of accessing okCommandUserChoice field directly.
     * @return Instance for okCommandUserChoice component
     **/
    private javax.microedition.lcdui.Command get_okCommandUserChoice() {
        if (okCommandUserChoice == null) {
            okCommandUserChoice = new javax.microedition.lcdui.Command("Ok", javax.microedition.lcdui.Command.OK, 1);
        }
        return okCommandUserChoice;
    }
    
    /**
     * This method returns instance for tableNameBox component and should be called instead of accessing tableNameBox field directly.
     * @return Instance for tableNameBox component
     **/
    private javax.microedition.lcdui.TextBox get_tableNameBox() {
        if (tableNameBox == null) {
            tableNameBox = new javax.microedition.lcdui.TextBox("Inserisci il nome della tabella", null, 120, 0x0);
            tableNameBox.addCommand(get_okCommandTableNameBox());
            tableNameBox.setCommandListener(this);
        }
        return tableNameBox;
    }
    
    /**
     * This method returns instance for okCommandTableNameBox component and should be called instead of accessing okCommandTableNameBox field directly.
     * @return Instance for okCommandTableNameBox component
     **/
    private javax.microedition.lcdui.Command get_okCommandTableNameBox() {
        if (okCommandTableNameBox == null) {
            okCommandTableNameBox = new javax.microedition.lcdui.Command("Ok", javax.microedition.lcdui.Command.OK, 1);
        }
        return okCommandTableNameBox;
    }
    
    /**
     * This method returns instance for selectResultbox component and should be called instead of accessing selectResultbox field directly.
     * @return Instance for selectResultbox component
     **/
    private javax.microedition.lcdui.TextBox get_selectResultbox() {
        if (selectResultbox == null) {
            selectResultbox = new javax.microedition.lcdui.TextBox(null, null, 120, 0x0);
            selectResultbox.addCommand(get_backCommandSelectResultBox());
            selectResultbox.setCommandListener(this);
        }
        return selectResultbox;
    }
    
    /**
     * This method returns instance for backCommandSelectResultBox component and should be called instead of accessing backCommandSelectResultBox field directly.
     * @return Instance for backCommandSelectResultBox component
     **/
    private javax.microedition.lcdui.Command get_backCommandSelectResultBox() {
        if (backCommandSelectResultBox == null) {
            backCommandSelectResultBox = new javax.microedition.lcdui.Command("Back", javax.microedition.lcdui.Command.BACK, 1);
        }
        return backCommandSelectResultBox;
    }
    
    javax.microedition.lcdui.List deviceFounded;
    javax.microedition.lcdui.Alert alertDiscoveryStart;
    javax.microedition.lcdui.Alert alertError;
    javax.microedition.lcdui.Command okCommandDiscoveryStart;
    javax.microedition.lcdui.Command exitBluetoothInitError;
    javax.microedition.lcdui.Ticker tickerDeviceSearch;
    javax.microedition.lcdui.Command stopCommand1;
    javax.microedition.lcdui.Command ViewServices;
    javax.microedition.lcdui.List servicesList;
    javax.microedition.lcdui.Command backToDeviceFounded;
    javax.microedition.lcdui.Alert alertSplashScreen;
    javax.microedition.lcdui.Image splashScreen;
    javax.microedition.lcdui.Alert alertService;
    javax.microedition.lcdui.Ticker tickerServiceList;
    javax.microedition.lcdui.Command connect;
    javax.microedition.lcdui.TextBox loginScreen;
    javax.microedition.lcdui.Command okCommandLoginScreen;
    javax.microedition.lcdui.Alert alertLoginIncorrect;
    javax.microedition.lcdui.Command okCommandLoginCorrect;
    javax.microedition.lcdui.Command updateValue;
    javax.microedition.lcdui.Alert alertLoginCorrect;
    javax.microedition.lcdui.Command okCommandLogincorrect;
    javax.microedition.lcdui.List userChoice;
    javax.microedition.lcdui.Command okCommandUserChoice;
    javax.microedition.lcdui.TextBox tableNameBox;
    javax.microedition.lcdui.Command okCommandTableNameBox;
    javax.microedition.lcdui.TextBox selectResultbox;
    javax.microedition.lcdui.Command backCommandSelectResultBox;
// --- This is the end of auto-generated section.//</editor-fold>//GEN-END:MVDMethods
    
    public void startApp() {
        initialize();
        
    }
    
    public void pauseApp() {
    }
    
    public void destroyApp(boolean unconditional) {
    }
    
    
    /**
     * per evitare possibili deadlock provocati da operazioni bloccanti (quali 
     * quelle relative al networking)  necessario implementare in un thread 
     * differente tutta la logica delle connessioni al server
     */
    public void run(){
       connect(); 
    }
    
    
    private void connect(){
        /*
         * recupero l'indice del servizio con cui  memorizzato nel vector a sua volta
         * presente in services
         * NB: i servizi vengono caricati nella list nello stesso ordine in cui sono
         * presenti nel Vector
         */
        int serviceIndex = get_servicesList().getSelectedIndex();
        String url ="";
        
        /*
         * recupero il valore chiave con cui  memorizzato il vettore di servizi
         * relativo alla device cui ci si vuole connetterre
         */
        Integer key = new Integer(get_deviceFounded().getSelectedIndex());
        Vector serviceVector = (Vector)services.get(key);
        ServiceRecord service = (ServiceRecord)serviceVector.elementAt(serviceIndex);
        
        try{
            conn = client.getConnection(service, ServiceRecord.NOAUTHENTICATE_NOENCRYPT,  false);
            this.streamFromServer = conn.openDataInputStream();
            this.streamToServer = conn.openDataOutputStream();
        }
        catch (ConnectionException e){
            /*
             * Non  possibile instaurare la connessione. visualizo l'opportuno alert
             */
            get_alertService().setTitle("Errore");
            get_alertService().setString(e.getMessage());
            javax.microedition.lcdui.Display.getDisplay(this).setCurrent(get_alertService());
        }
        
         catch (IOException e){
            /*
             * Non  possibile instaurare la connessione. visualizo l'opportuno alert
             */
            get_alertService().setTitle("Errore");
            get_alertService().setString(e.getMessage());
            javax.microedition.lcdui.Display.getDisplay(this).setCurrent(get_alertService());
        }
        
        
        //TODO se la connessione va a buon fine bisogna svuotare le hashtable per ottimizzare memoria
        //TODO la prima cosa che devo fare  inviare la login alla midlet server
        
    }
    
    
    private void setupServiceSearchIndicator(){
        try{
            serviceSearchInProgress = Image.createImage("/images/searching.png");
        } catch(IOException e){
            //TODO si pu creare un off screen image (?) come in example.bluetooth.demo.ServerMIDlet.setupIndicatorImage()
            ;
        }
        
        try{
            serviceSearchDone = Image.createImage("/images/searchDone.png");
        } catch(IOException e){
            //TODO si pu creare un off screen image (?) come in example.bluetooth.demo.ServerMIDlet.setupIndicatorImage()
            ;
        }
        
        try{
            serviceSearchError = Image.createImage("/images/noServiceFound.png");
        } catch(IOException e){
            //TODO si pu creare un off screen image (?) come in example.bluetooth.demo.ServerMIDlet.setupIndicatorImage()
            ;
        }
        
    }
    
    /**
     * _________________________________________________________________________
     * 
     * Implementazione dei metodi appartenenti all'interfaccia DiscoveryEventHandler
     *
     * _________________________________________________________________________
     *
     */
    
    public void discoveryStarted(){
        System.out.println("discovery partito");
 
    }
    
    
    public void discoveryError(DiscoveryError error){
        //visualizzo l'alert di errore con un opportuno messaggio
        get_alertError().setString(error.getMsg());
        javax.microedition.lcdui.Display.getDisplay(this).setCurrent(get_alertError());
        
    }
    
    public void serviceSearchStarted(Enumeration devices){
        System.out.println("Ricerca servizi iniziata");
        
        get_tickerDeviceSearch().setString("Ricerca servizi sulle device trovate in corso");
        
        while(devices.hasMoreElements()){
            RemoteDevice rd = (RemoteDevice)devices.nextElement();
            String deviceName;
            try{
                deviceName = rd.getFriendlyName(true);
            } catch(IOException e){
                deviceName = rd.getBluetoothAddress();
            }
            
            //aggiorno il componente deviceFounded
            int index = get_deviceFounded().append(deviceName, serviceSearchInProgress);
            
            //..e l'hashtable deviceListIndex
            deviceListIndex.put(rd, new Integer(index));
        }
        
    }
    
    public void serviceSearchError(ServiceSearchError error){
        System.out.println("Errore durante la ricerca dei servizi " + error.getMsg());
        
        //aggiorno la remote device dall'error
        RemoteDevice rd = error.getRemoteDevice();
        
        /*
         * Se la condizione di questo if non  vera, significa che  finita una
         * ricerca con id non previsto
         */
        if (rd != null){
            //recupero l'indice in deviceFounded corrispondente a rd
            Integer index = (Integer)deviceListIndex.get(rd);
            
            //aggiorno l'immagine
            String stringPart = get_deviceFounded().getString(index.intValue());
            get_deviceFounded().set(index.intValue(), stringPart, serviceSearchError);
            
            //aggiorno l'hashtable delgi errori di ricerca servizi
            serviceSearchErrorMsg.put(index, error.getMsg());
        }
        
        
        
    }
    
    
    public void servicesFound(Vector services, RemoteDevice rd){
        System.out.println("Servizio trovato");
        
        //recupero l'indice in deviceFounded corrispondente a rd
        Integer index = (Integer)deviceListIndex.get(rd);
        
        //aggiorno l'immagine
        String stringPart = get_deviceFounded().getString(index.intValue());
        get_deviceFounded().set(index.intValue(), stringPart, serviceSearchDone);
        
        
        //aggiorno l'hashtable di servizi
        this.services.put(index, services);
    }
    
    
    public void discoveryCompleted(DiscoveryReport report){
        
        String msg = "Discovery completato";
        System.out.println(msg);
        if(report.deviceCount() == 0){
            msg += "nessuna periferica trovata";
            System.out.println("nessuna periferica trovata");
        }
        get_tickerDeviceSearch().setString(msg);
        
    }
    
    /**
     * _________________________________________________________________________
     * 
     * Implementazione dei metodi appartenenti alle interfacce 
     * XResponseHandler e AccountingResponseHandler
     * _________________________________________________________________________
     */
    
    public void connectionError(){
       
        try{
            this.conn.close();
        }
        
        catch(IOException e){
            ;
        }
        
        finally{
            this.conn = null;
        }
     
    }
    
    public void handleMessageResponse(String message){
       get_selectResultbox().setString(message);
    }
    
    public void handleRowResponse(Vector rows){
        //TODO implementami
    }
    
    public void loginIncorrect(String msg){
        
        /*
         *la login non  andata a buon fine. visualizzo un opportuno dialog 
         */ 
        get_alertLoginIncorrect().setString(msg);
        javax.microedition.lcdui.Display.getDisplay(this).setCurrent(get_alertLoginIncorrect());
    }
    
    public void loginCorrect(String msg){
        /*
         *la login   andata a buon fine. visualizzo un opportuno dialog 
         */ 
        get_alertLoginCorrect().setString(msg);
        javax.microedition.lcdui.Display.getDisplay(this).setCurrent(get_alertLoginCorrect());
        
    }
}
