import org.jaebi.midlet.bt.btException.BtIOException;
import org.jaebi.midlet.bt.requestProcessing.XRequestProcessor;
import org.jaebi.midlet.bt.requestProcessing.RequestProcessor;
import org.jaebi.midlet.bt.responseHandling.AccountingResponseHandler;
/*
 * LoginRequestProcessor.java
 *
 * Created on 21 giugno 2005, 13.52
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

/**
 * Estensione concreta di un request Processor. 
 * Gestisce tutte lengthoperazioni riguardanti l'operazione di login:
 * <li>
 * <ul>Invia la richiesta alla midlet server</ul>
 * <ul>Attende il response dal Ws che lengthviene inoltrato dalla midlet server</ul>
 * <ul>richiama l'ooportuno metodo di AccountingResponseHandler</ul>
 * </li>
 * @author Antonio
 */
public class LoginRequestProcessor extends RequestProcessor{
    
    private String nickName;
    private static final String USERTYPE = "Midlet";
    
    /** Creates a new instance of LoginRequestProcessor */
    public LoginRequestProcessor() {
    }
    
    
    public void setNickName(String nickName){
        this.nickName = nickName.trim();
    }
    
    
    public void run(){
        String response = "";
        String requestBeginMarker = "[login]";
        String requestEndMarker = "[/login]";
        String responseBeginMarker = "[login_response]";
        String responseEndMarker = "[/login_response]";
        
        try{
            this.sendRequest(requestBeginMarker + this.nickName + " " + USERTYPE + requestEndMarker);
            response= this.getResponseContent(responseBeginMarker, responseEndMarker);
        }
        catch(BtIOException e){
            
            /*
             * si  verificato un errore durante la comunicazione. Lo notifico
             * attraverso l'handler
             */
            this.handler.connectionError();
            return;
        }
        
        
       
        if (response.equals("ok"))
            ((AccountingResponseHandler)handler).loginCorrect("Autenticazione effettuata con successo");
        else
            ((AccountingResponseHandler)handler).loginIncorrect("Autenticazione non riuscita causa errore interno o username errato");
        
    }
    
}
