/*
 * ServerMidlet.java
 *
 * Created on 28 maggio 2005, 18.45
 */

import java.io.IOException;
import java.rmi.RemoteException;
import java.util.Vector;
import javax.bluetooth.RemoteDevice;
import javax.bluetooth.UUID;
import javax.microedition.io.StreamConnection;
import javax.microedition.midlet.*;
import org.jaebi.midlet.bt.btException.BtInitException;
import org.jaebi.midlet.bt.*;


/**
 *
 * @author Antonio
 */
public class ServerMidlet extends MIDlet implements javax.microedition.lcdui.CommandListener, ConnectionEventHandler {
    
    private StringBuffer url;
    private BtServer btServer;
    
    private String serviceURL = "http://192.168.1.11:8080/JAEBI/JAEBIWS";

    
    //definisco una costante che memorizza l'UUID (puramente esemplificativo) della device bluetooth
    private static final UUID JAEBI_MIDLET_UUID = new UUID(0x12345);
    
    /*
     * vettore di RemoteDevice. Contiene gli handle alle device connesse a
     * questo server, indicizzate nello stesso ordine in cui sono
     * rappresentate nel componente List connectdeDevice
     */
    private Vector connected;
    
    /*
     * Vector di StreamConnections. Contiene gli handle alle connessioni attive
     * su questo server. Una connessione x presente in questo container avr
     * indice uguale all'indice con cui la relativa remotedevice  memorizzata
     * in connected
     */
    private Vector connections;
    
    /**
     * Vector di ConnectionProcessor. Contiene gli handle alle istanze di
     * ConnectionProcessor, la classe che si occupa di gestire ogni singola
     * connessione al server. L'istanza di ConnectionProcessor che gestisce la
     * connessione relativa alla remoteDevice x  memorizzata in questo
     * container con lo stesso indice con cui x  memorizzata in connected e con
     * cui la connessione relativa ad x  memorizzata in connections
     */
    private Vector connectionProcessors;
    
    /** Creates a new instance of ServerMidlet */
    public ServerMidlet() {
        
            /*
             *******************************************************************
             * costruisco la stringa contenete l'url del server e che verr
             * passata al costruttore di BtServer
             *******************************************************************
             */
        
        //usiamo il profilo serial Port Profile per le connessioni
        url = new StringBuffer("btspp://");
        
        // indico nell'url che si tratta di un server
        url.append("localhost").append(':');
        
        // aggiungo l'UUID per identificare il servizio
        url.append(JAEBI_MIDLET_UUID.toString());
        
        // Aggiungo il nome per il nostro servizio
        url.append(";name=Midlet_Server");
        
        // richiedo che i client siano autorizzati
        //TODO in che senso autorizzati!?!?
        url.append(";authorize=true");
        
        //TODO debug
        System.out.println("UUID=" + JAEBI_MIDLET_UUID.toString());
        
        this.connected = new Vector();
        this.connections = new Vector();
        this.connectionProcessors = new Vector();
        
    }
    
// --- This section is auto-generated by NetBeans IDE. Do not modify or you may lose your changes.//<editor-fold id="MVDMethods" defaultstate="collapsed" desc="This section is auto-generated by NetBeans IDE.">//GEN-BEGIN:MVDMethods
    /**
     * This method initializes UI of the application.
     */
    private void initialize() {
// For adding user code into this block, select "Design" item in the inspector and invoke property editor on Action property in Properties window.
        javax.microedition.lcdui.Display.getDisplay(this).setCurrent(get_alertSplashScreen());
    }
    
    /**
     * Called by the system to indicate that a command has been invoked on a particular displayable.
     * @param command the Command that ws invoked
     * @param displayable the Displayable on which the command was invoked
     **/
    public void commandAction(javax.microedition.lcdui.Command command, javax.microedition.lcdui.Displayable displayable) {
        if (displayable == connectedDevice) {
            if (command == info) {
// For adding user code into this block, select "Design | Screens | connectedDevice [List] | Assigned Commands | info" item in the inspector and invoke property editor on Action property in Properties window.
                javax.microedition.lcdui.Display.getDisplay(this).setCurrent(get_deviceInfo(), get_connectedDevice());
            }
        } else if (displayable == initAlert) {
            if (command == exitCommand1) {
// For adding user code into this block, select "Design | Screens | initAlert [Alert] | Assigned Commands | exitCommand1" item in the inspector and invoke property editor on Action property in Properties window.
                javax.microedition.lcdui.Display.getDisplay(this).setCurrent(null);
                destroyApp(true);
                notifyDestroyed();
            }
        }
    }
    
    /**
     * This method returns instance for initAlert component and should be called instead of accessing initAlert field directly.
     * @return Instance for initAlert component
     **/
    private javax.microedition.lcdui.Alert get_initAlert() {
        if (initAlert == null) {
            initAlert = new javax.microedition.lcdui.Alert(null, "Si \u00E8 verificato un errore durante l\'inizializzazione della periferica bluetooth", null, javax.microedition.lcdui.AlertType.INFO);
            initAlert.addCommand(get_exitCommand1());
            initAlert.setCommandListener(this);
            initAlert.setTimeout(-2);
        }
        return initAlert;
    }
    
    /**
     * This method returns instance for exitCommand1 component and should be called instead of accessing exitCommand1 field directly.
     * @return Instance for exitCommand1 component
     **/
    private javax.microedition.lcdui.Command get_exitCommand1() {
        if (exitCommand1 == null) {
            exitCommand1 = new javax.microedition.lcdui.Command("Exit", javax.microedition.lcdui.Command.EXIT, 1);
        }
        return exitCommand1;
    }
    
    /**
     * This method returns instance for ticker1 component and should be called instead of accessing ticker1 field directly.
     * @return Instance for ticker1 component
     **/
    private javax.microedition.lcdui.Ticker get_ticker1() {
        if (ticker1 == null) {
            ticker1 = new javax.microedition.lcdui.Ticker("In attesa di connesioni da parte di altre device");
        }
        return ticker1;
    }
    
    /**
     * This method returns instance for alertSplashScreen component and should be called instead of accessing alertSplashScreen field directly.
     * @return Instance for alertSplashScreen component
     **/
    private javax.microedition.lcdui.Alert get_alertSplashScreen() {
        if (alertSplashScreen == null) {
            alertSplashScreen = new javax.microedition.lcdui.Alert(null, "", get_logo(), javax.microedition.lcdui.AlertType.INFO);
            alertSplashScreen.setTimeout(3000);
            try{
                btServer = new BtServer(this.url, this);
            }catch(BtInitException e){
                javax.microedition.lcdui.Display.getDisplay(this).setCurrent(get_initAlert());
                e.printStackTrace();
            }
            javax.microedition.lcdui.Display.getDisplay(this).setCurrent(get_connectedDevice());
        }
        return alertSplashScreen;
    }
    
    /**
     * This method returns instance for logo component and should be called instead of accessing logo field directly.
     * @return Instance for logo component
     **/
    private javax.microedition.lcdui.Image get_logo() {
        if (logo == null) {
            try {
                logo = javax.microedition.lcdui.Image.createImage("/images/jaebi LogoFinal.jpg");
            } catch (java.io.IOException exception) {
            }
        }
        return logo;
    }
    
    /**
     * This method returns instance for connectedDevice component and should be called instead of accessing connectedDevice field directly.
     * @return Instance for connectedDevice component
     **/
    private javax.microedition.lcdui.List get_connectedDevice() {
        if (connectedDevice == null) {
            connectedDevice = new javax.microedition.lcdui.List(null, javax.microedition.lcdui.Choice.IMPLICIT, new java.lang.String[0], new javax.microedition.lcdui.Image[0]);
            connectedDevice.addCommand(get_Disconnect());
            connectedDevice.addCommand(get_info());
            connectedDevice.setCommandListener(this);
            connectedDevice.setTicker(get_tickerConnectedDevice());
            connectedDevice.setSelectedFlags(new boolean[0]);
            connectedDevice.setSelectCommand(get_Disconnect());
        }
        return connectedDevice;
    }
    
    /**
     * This method returns instance for Disconnect component and should be called instead of accessing Disconnect field directly.
     * @return Instance for Disconnect component
     **/
    private javax.microedition.lcdui.Command get_Disconnect() {
        if (Disconnect == null) {
            Disconnect = new javax.microedition.lcdui.Command("Disconnect", javax.microedition.lcdui.Command.ITEM, 1);
        }
        return Disconnect;
    }
    
    /**
     * This method returns instance for info component and should be called instead of accessing info field directly.
     * @return Instance for info component
     **/
    private javax.microedition.lcdui.Command get_info() {
        if (info == null) {
            info = new javax.microedition.lcdui.Command("Info", javax.microedition.lcdui.Command.SCREEN, 1);
        }
        return info;
    }
    
    /**
     * This method returns instance for deviceInfo component and should be called instead of accessing deviceInfo field directly.
     * @return Instance for deviceInfo component
     **/
    private javax.microedition.lcdui.Alert get_deviceInfo() {
        if (deviceInfo == null) {
            deviceInfo = new javax.microedition.lcdui.Alert(null, "<Enter Text>", null, javax.microedition.lcdui.AlertType.INFO);
            deviceInfo.setTimeout(-2);
        }
        return deviceInfo;
    }
    
    /**
     * This method returns instance for tickerConnectedDevice component and should be called instead of accessing tickerConnectedDevice field directly.
     * @return Instance for tickerConnectedDevice component
     **/
    private javax.microedition.lcdui.Ticker get_tickerConnectedDevice() {
        if (tickerConnectedDevice == null) {
            tickerConnectedDevice = new javax.microedition.lcdui.Ticker("Al momento ci sono 0 connessioni attive");
        }
        return tickerConnectedDevice;
    }
    
    javax.microedition.lcdui.Alert initAlert;
    javax.microedition.lcdui.Command exitCommand1;
    javax.microedition.lcdui.Ticker ticker1;
    javax.microedition.lcdui.Alert alertSplashScreen;
    javax.microedition.lcdui.Image logo;
    javax.microedition.lcdui.List connectedDevice;
    javax.microedition.lcdui.Command Disconnect;
    javax.microedition.lcdui.Command info;
    javax.microedition.lcdui.Alert deviceInfo;
    javax.microedition.lcdui.Ticker tickerConnectedDevice;
// --- This is the end of auto-generated section.//</editor-fold>//GEN-END:MVDMethods
    
    public void startApp() {
        initialize();
    }
    
    public void pauseApp() {
    }
    
    public void destroyApp(boolean unconditional) {
        //TODO in questo metodo devono essere distrutte tutte le connessioni del listner
    }
    
    
    public void connectionAdded(StreamConnection conn){
        /**
         * recupero il friendly name (o il suo indirizzo) della device che si  collegata
         */
        String nameOrAddress;
        RemoteDevice rd = null;
        ConnectionProcessor cp = null;
        
        try{
            rd = RemoteDevice.getRemoteDevice(conn);
        } catch (IOException  ex){
            
            /*
             * qualcosa non va: non riesco a recuperare l'handle alla
             * RemoteDevice cui si riferisce la connessione. Rimuovo il
             * riferimento alla connessione in bTServer e non faccio nient'altro
             */
            btServer.removeConnection(conn);
            return;
        }
        
        try{
            nameOrAddress = rd.getFriendlyName(true);
        } catch(IOException e){
            nameOrAddress = rd.getBluetoothAddress();
        }
        
        /*
         * Aggiorno il componente List connectedDevice
         */
        get_connectedDevice().append(nameOrAddress, null);
        
        /*
         * aggiungo in connected l'handle alla remotedevice connessa
         */
        connected.addElement(rd);
        
        /*
         * aggiungo l'handle alla connessione a connections
         */
        connections.addElement(conn);
        
        /*
         * faccio partire il thread di gestione della connessione
         */
       cp = new ConnectionProcessor(conn, this.btServer, this.serviceURL);
        
        /*
         * aggiungo l'handle all'istanza di ConnectionProcessor a connectionProcessors
         */
        connectionProcessors.addElement(cp);
        
        get_tickerConnectedDevice().setString("Al momento ci sono " + connections.size() + "connessioni attive");
    }
    
    
    public void connectionRemoved(StreamConnection conn){
        
        //recupero l'indice della connessione in connections
        int index = connections.indexOf(conn);
        
        /*
         * Verifico se  necessario aggiornare conneced, connections e
         * connectionProcessors (potrebbe non esserlo a causa del primo
         * try..catch all'interno del metodo connectionAdded()
         */
        if (index != -1){
            
            //rimuovo la connessione da connections
            connections.removeElementAt(index);
            
            /* rimuovo da connectionProcessors l'istanza di ConnecionProcessor che
             * gestiva la connessione rimossa
             */
            connectionProcessors.removeElementAt(index);
            
            /*
             * rimuovo da connected l'handle alla RemoteDevice relativa alla
             * connessione rimossa
             */
            connected.removeElementAt(index);
        }
        
        get_tickerConnectedDevice().setString("Al momento ci sono " + connections.size() + "connessioni attive");
    }
    
}
