/**
 * BtServer.java
 *
 * Created on 27 maggio 2005, 18.28
 * 
 *
 */


package org.jaebi.midlet.bt;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Vector;
import javax.microedition.io.StreamConnection;
import org.jaebi.midlet.bt.btException.BtIOException;
import org.jaebi.midlet.bt.btException.BtInitException;



/**
 *Questa classe fornisce gli strumenti necessari per implementare e quindi 
 * gestire un server bluetooth. Gli handler di tutte le connessioni attive 
 * vengono conservati in un'istanza di ConnectionSet, monitorata da un ConnectionObserver
 * che questa classe si incarica di istanziare. 
 * Nel momento in cui si istanzia questa classe, viene lanciato in esecuzione un 
 * thread in continuo ascolto di nuove connessioni in entrata. Nel momento in 
 * cui una nuova connessione viene rilevata, essa viene aggiunta al pool di 
 * connessioni attive
 *
 * @author Antonio
 */
public class BtServer extends Listener implements Runnable{
    
    private ConnectionSet connections;
    private ConnectionEventHandler connectionEventHandler;
    private ConnectionObserver connectionObserver;
    
    /** Creates a new instance of BtServer */
    //TODO implementare un metodo destroy per chiudere tutte le connessioni e rilasciare le risorse occupate (distruggere i cp allocati)
    public BtServer(StringBuffer url, ConnectionEventHandler handler) throws BtInitException{
        super(url);
        this.connectionEventHandler = handler;
        this.connectionObserver = new ConnectionObserver(this.connectionEventHandler);
        this.connections = new ConnectionSet(connectionObserver);
        
        //faccio partire il thread di ascolto
        new Thread(this).start();
    }
    

    public void removeConnection(StreamConnection conn){
        this.connections.removeConnection(conn);
    }
    
    public void run(){
        while(!isClosed()){
            StreamConnection conn = null ;
            conn = listen();
            connections.addConnection(conn);
        }
        
    }
    
    
    
    
}
