/*
 * DiscovererObserver.java
 *
 * Created on 9 giugno 2005, 13.26
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package org.jaebi.midlet.bt;

import java.util.Enumeration;
import java.util.Vector;
import javax.bluetooth.RemoteDevice;
import org.jaebi.midlet.util.Observable;
import org.jaebi.midlet.util.Observer;
import org.jaebi.midlet.bt.discoveryHandling.DiscoveryEventHandler;
import org.jaebi.midlet.bt.discoveryHandling.ServiceSearchError;
import org.jaebi.midlet.bt.discoveryHandling.DiscoveryError;

/**
 *
 * @author Antonio
 */
public class DiscovererObserver implements Observer {
    
    private DiscoveryEventHandler eventHandler;
    
    
    
    public DiscovererObserver(DiscoveryEventHandler eventHandler) {
        this.eventHandler = eventHandler;
    }
    
    
    public void update(Observable o, Object arg){
        Discoverer discoverer = (Discoverer)o;
        DiscoveryError discoveryError =  null ;
        Enumeration devices = null;
        int discovererState = discoverer.getState();
        
        switch (discovererState){
            case DiscovererState.DEVICE_SEARCH:
                eventHandler.discoveryStarted();
                break;
                
            case DiscovererState.DISCOVERY_ERROR:
                discoveryError = (DiscoveryError)arg;
                eventHandler.discoveryError((DiscoveryError)arg);
                break;
                
            case DiscovererState.SERVICE_SEARCH:
                
                    devices = discoverer.getDiscoveryReport().getDevices();
               
                eventHandler.serviceSearchStarted(devices);
                break;
                
            case DiscovererState.NEW_SERVICE_SEARCH_ERROR:
                discoveryError = (DiscoveryError)arg;
                eventHandler.serviceSearchError((ServiceSearchError)arg);
                break;
                
            case DiscovererState.NEW_SERVICE_SEARCH_COMPLETE:
                RemoteDevice rd = (RemoteDevice)arg;
                Vector services = discoverer.getDiscoveryReport().getServices(rd);
                /*
                 * Recupero la device a cui sono associati i servizi. Tutti i
                 * servizi si riferiscono alla medesima device, sono sicuro che
                 * il vector contiene almeno un servizio (perch diversamente ci 
                 * si troverebbe nel case relativo a NEW_SERVICE_SEARCH_ERROR) quindi
                 * recupero la device dal primo elemento del record
                 */
                
                eventHandler.servicesFound(services, rd);
                break;
                
            case DiscovererState.READY:
                eventHandler.discoveryCompleted(discoverer.getDiscoveryReport());
                break;
        }
        
        
    }
    
}
