/*
 * DiscoveryReport.java
 *
 * Created on 6 giugno 2005, 10.20
 *
 * Questa classe incapsula il risultato delle ricerche di device e servizi
 *TODO controllare se  necessaria sincronizzazione.Considera che c' un flusso di controllo principale (della midlet) che pu cancellare lengthricerche in qualsiasi
 *momento, un flusso di controllo del thread lanciato da searchDeviceServices(), un flusso di controllo per ogni device trovata (quelli dei thread lanciati da discoveryAgent.searchServices)
 */

package org.jaebi.midlet.bt.discoveryHandling;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;
import javax.bluetooth.RemoteDevice;
import javax.bluetooth.ServiceRecord;

/**
 *
 * @author Antonio
 */
public class DiscoveryReport {
    /** Hashtable contenente le device trovate durante un inquiry 
     *  Ogni elemento dell'hashtable (memorizzato in chiave dell'istanza di 
     *  RemoteDevice che incapsula la bluetooth device)  un Vector 
     *  di ServiceRecord che rappresenta i servizi diaponibili su quella 
     *  periferica
     */
    private Hashtable services;
    
    
    /** Creates a new instance of DiscoveryReport */
    public DiscoveryReport() {
        services = new Hashtable();
    }
    
    
    public void addDevice(RemoteDevice toAdd){
        if(services.containsKey(toAdd))
            return;
        
        Vector services = new Vector();
        this.services.put(toAdd, services);
    }
    
    public void addService(ServiceRecord service){
        RemoteDevice rd = service.getHostDevice();
        ((Vector)services.get(rd)).addElement(service);
    }
    
    /**
     * recupera i servizi offerti dalla device passata come parametro
     * @param device la device bluetooth di cui si desidera recuperare i servizi 
     * trovati
     * @returns un Vector di ServiceRecord (tutti quelli relativi a <code>rd
     * </code>) null se rd non  mappata tra i report
     */
    public Vector getServices(RemoteDevice device){
        Vector out;
        out = (Vector)services.get(device);
        return out;
    }
    
    public void clear(){
        Enumeration en;
        en = services.elements();
        while (en.hasMoreElements()){
            ((Vector)en.nextElement()).removeAllElements();
        }
        services.clear();
    }
    
    
    public int deviceCount(){
        return services.size();
    }
    
    
    public Enumeration getDevices(){
        Enumeration devices = services.keys();
        return devices;
    }
    
 
    
    
    
    
    
}
